Index: /trunk/src/emx/src/lib/iconv/iconv.c
===================================================================
--- /trunk/src/emx/src/lib/iconv/iconv.c	(revision 648)
+++ /trunk/src/emx/src/lib/iconv/iconv.c	(revision 649)
@@ -1,23 +1,3 @@
-/* OS/2 iconv() implementation through OS/2 Unicode API
-   Copyright (C) 2001-2002 Free Software Foundation, Inc.
-
-   This program is free software; you can redistribute it and/or modify it
-   under the terms of the GNU Library General Public License as published
-   by the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Library General Public License for more details.
-
-   You should have received a copy of the GNU Library General Public
-   License along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
-   USA.  */
-
-/*
-   This file implements an iconv wrapper based on OS/2 Unicode API.
-*/
+/* iconv wrapper based on OS/2 Unicode API. */
 
 #include <uconv.h>
Index: /trunk/src/emx/src/lib/io/_tempnam.c
===================================================================
--- /trunk/src/emx/src/lib/io/_tempnam.c	(revision 648)
+++ /trunk/src/emx/src/lib/io/_tempnam.c	(revision 649)
@@ -28,5 +28,5 @@
 
 
-char *_tempnam (const char *dir, const char *prefix)
+char *_STD(tempnam) (const char *dir, const char *prefix)
 {
   const char *tmpdir;
Index: /trunk/src/emx/src/lib/termios/cfgetisp.c
===================================================================
--- /trunk/src/emx/src/lib/termios/cfgetisp.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/cfgetisp.c	(revision 649)
@@ -4,5 +4,5 @@
 #include <sys/termio.h>         /* CBAUD */
 
-speed_t _cfgetispeed (const struct termios *ptermios)
+speed_t _STD(cfgetispeed) (const struct termios *ptermios)
 {
   return ptermios->c_cflag & CBAUD;
Index: /trunk/src/emx/src/lib/termios/cfgetosp.c
===================================================================
--- /trunk/src/emx/src/lib/termios/cfgetosp.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/cfgetosp.c	(revision 649)
@@ -4,5 +4,5 @@
 #include <sys/termio.h>         /* CBAUD */
 
-speed_t _cfgetospeed (const struct termios *ptermios)
+speed_t _STD(cfgetospeed) (const struct termios *ptermios)
 {
   return ptermios->c_cflag & CBAUD;
Index: /trunk/src/emx/src/lib/termios/cfsetisp.c
===================================================================
--- /trunk/src/emx/src/lib/termios/cfsetisp.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/cfsetisp.c	(revision 649)
@@ -4,8 +4,6 @@
 #include <errno.h>
 
-int _cfsetspeed (struct termios *ptermios, speed_t speed);
-
-int _cfsetispeed (struct termios *ptermios, speed_t speed)
+int _STD(cfsetispeed) (struct termios *ptermios, speed_t speed)
 {
-  return _cfsetspeed (ptermios, speed);
+  return cfsetspeed (ptermios, speed);
 }
Index: /trunk/src/emx/src/lib/termios/cfsetosp.c
===================================================================
--- /trunk/src/emx/src/lib/termios/cfsetosp.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/cfsetosp.c	(revision 649)
@@ -3,8 +3,6 @@
 #include <termios.h>
 
-int _cfsetspeed (struct termios *ptermios, speed_t speed);
-
-int _cfsetospeed (struct termios *ptermios, speed_t speed)
+int _STD(cfsetospeed) (struct termios *ptermios, speed_t speed)
 {
-  return _cfsetspeed (ptermios, speed);
+  return cfsetspeed (ptermios, speed);
 }
Index: /trunk/src/emx/src/lib/termios/cfsetspe.c
===================================================================
--- /trunk/src/emx/src/lib/termios/cfsetspe.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/cfsetspe.c	(revision 649)
@@ -5,5 +5,5 @@
 #include <sys/termio.h>         /* CBAUD */
 
-int _cfsetspeed (struct termios *ptermios, speed_t speed)
+int _STD(cfsetspeed) (struct termios *ptermios, speed_t speed)
 {
   /* speed is always >= B0 as speed_t is unsigned and B0 is zero. */
Index: /trunk/src/emx/src/lib/termios/tcdrain.c
===================================================================
--- /trunk/src/emx/src/lib/termios/tcdrain.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/tcdrain.c	(revision 649)
@@ -4,5 +4,5 @@
 #include <sys/ioctl.h>
 
-int _tcdrain (int handle)
+int _STD(tcdrain) (int handle)
 {
   return ioctl (handle, TCSBRK, 1);
Index: /trunk/src/emx/src/lib/termios/tcflow.c
===================================================================
--- /trunk/src/emx/src/lib/termios/tcflow.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/tcflow.c	(revision 649)
@@ -4,5 +4,5 @@
 #include <sys/ioctl.h>
 
-int _tcflow (int handle, int action)
+int _STD(tcflow) (int handle, int action)
 {
   return ioctl (handle, TCXONC, action);
Index: /trunk/src/emx/src/lib/termios/tcflush.c
===================================================================
--- /trunk/src/emx/src/lib/termios/tcflush.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/tcflush.c	(revision 649)
@@ -4,5 +4,5 @@
 #include <sys/ioctl.h>
 
-int _tcflush (int handle, int queue)
+int _STD(tcflush) (int handle, int queue)
 {
   return ioctl (handle, TCFLSH, queue);
Index: /trunk/src/emx/src/lib/termios/tcgetatt.c
===================================================================
--- /trunk/src/emx/src/lib/termios/tcgetatt.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/tcgetatt.c	(revision 649)
@@ -4,5 +4,5 @@
 #include <sys/ioctl.h>
 
-int _tcgetattr (int handle, struct termios *ptermios)
+int _STD(tcgetattr) (int handle, struct termios *ptermios)
 {
   return ioctl (handle, _TCGA, ptermios);
Index: /trunk/src/emx/src/lib/termios/tcgetpgr.c
===================================================================
--- /trunk/src/emx/src/lib/termios/tcgetpgr.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/tcgetpgr.c	(revision 649)
@@ -5,5 +5,5 @@
 #include <sys/types.h>
 
-pid_t _tcgetpgrp (int fd)
+pid_t _STD(tcgetpgrp) (int fd)
 {
   errno = ENOSYS;
Index: /trunk/src/emx/src/lib/termios/tcsendbr.c
===================================================================
--- /trunk/src/emx/src/lib/termios/tcsendbr.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/tcsendbr.c	(revision 649)
@@ -5,5 +5,5 @@
 #include <sys/ioctl.h>
 
-int _tcsendbreak (int handle, int duration)
+int _STD(tcsendbreak) (int handle, int duration)
 {
   return ioctl (handle, TCSBRK, duration);
Index: /trunk/src/emx/src/lib/termios/tcsetatt.c
===================================================================
--- /trunk/src/emx/src/lib/termios/tcsetatt.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/tcsetatt.c	(revision 649)
@@ -5,5 +5,5 @@
 #include <sys/ioctl.h>
 
-int _tcsetattr (int handle, int options, const struct termios *ptermios)
+int _STD(tcsetattr) (int handle, int options, const struct termios *ptermios)
 {
   int request;
Index: /trunk/src/emx/src/lib/termios/tcsetpgr.c
===================================================================
--- /trunk/src/emx/src/lib/termios/tcsetpgr.c	(revision 648)
+++ /trunk/src/emx/src/lib/termios/tcsetpgr.c	(revision 649)
@@ -5,5 +5,5 @@
 #include <sys/types.h>
 
-int _tcsetpgrp (int fd, pid_t pgrp)
+int _STD(tcsetpgrp) (int fd, pid_t pgrp)
 {
   errno = ENOSYS;
Index: /trunk/src/emx/src/libiconv/iconv.c
===================================================================
--- /trunk/src/emx/src/libiconv/iconv.c	(revision 648)
+++ /trunk/src/emx/src/libiconv/iconv.c	(revision 649)
@@ -1,23 +1,3 @@
-/* OS/2 iconv() implementation through OS/2 Unicode API
-   Copyright (C) 2001-2002 Free Software Foundation, Inc.
-
-   This program is free software; you can redistribute it and/or modify it
-   under the terms of the GNU Library General Public License as published
-   by the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Library General Public License for more details.
-
-   You should have received a copy of the GNU Library General Public
-   License along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
-   USA.  */
-
-/*
-   This file implements an iconv wrapper based on OS/2 Unicode API.
-*/
+/* iconv wrapper based on OS/2 Unicode API. */
 
 #include <uconv.h>